#!/usr/local/bin/ruby -w
# glut wrapper for SDL by Kouichirou@Eto.com 2001/09/21

require 'sdl'

module GLUT
  class GLUTWrapper
    def initialize
    end
  end

  #----------------------------------------------------------------------
  DEFAULT_WIDTH, DEFAULT_HEIGHT = 200, 200
  DEFAULT_FRAMERATE = 30
  def GLUT.Init()
    SDL.init(SDL::INIT_VIDEO)
    SDL.setGLAttr(SDL::GL_DOUBLEBUFFER, 1)
    $event = SDL::Event.new
    $display_func = Proc.new {}
    $reshape_func = Proc.new {}
    $keyboard_func = Proc.new {}
    $width, $height = DEFAULT_WIDTH, DEFAULT_HEIGHT
  end
  def GLUT.InitWindowSize(a,b)
    $width, $height = a,b
  end
  def GLUT.CreateWindow(a=nil)
    $screen = SDL.setVideoMode($width, $height, 0, SDL::OPENGL)
    GC.start
    SDL::WM.setCaption(a, a) if a != nil
  end
  
  def GLUT.MainLoop()
    $reshape_func.call($width, $height)
    loop {
      GL.Clear(GL::COLOR_BUFFER_BIT | GL::DEPTH_BUFFER_BIT)
      $display_func.call
      SDL.GLSwapBuffers
      GC.start
      GLUT.check_event;
      GLUT.delay;
    }
  end

  #----------------------------------------------------------------------SDL
  def GLUT.delay(msec=1000/DEFAULT_FRAMERATE) sleep msec/1000.0 end
  def GLUT.check_event
    e = $event
    while e.poll != 0
      case e.type
      when SDL::Event::KEYDOWN
	key = e.info[2]	#p [$v.event, $v.event.type, $v.event.info]
	exit if key == SDL::Key::ESCAPE #I`FbN
	$keyboard_func.call(key, 0, 0)
      when SDL::Event::QUIT
	exit
      end
    end
  end

  #----------------------------------------------------------------------set callback
  def GLUT.DisplayFunc(a) $display_func = a; end
  def GLUT.ReshapeFunc(a) $reshape_func = a; end
  def GLUT.KeyboardFunc(a) $keyboard_func = a; end

  #----------------------------------------------------------------------shapes
  def GLUT.WireSphere(a,b,c)
  end
  def GLUT.SolidSphere(a,b,c)
  end

  def GLUT.drawBox(size, type)
    n = [
      [-1.0, 0.0, 0.0],
      [0.0, 1.0, 0.0],
      [1.0, 0.0, 0.0],
      [0.0, -1.0, 0.0],
      [0.0, 0.0, 1.0],
      [0.0, 0.0, -1.0]]
    faces = [
      [0, 1, 2, 3],
      [3, 2, 6, 7],
      [7, 6, 5, 4],
      [4, 5, 1, 0],
      [5, 6, 2, 1],
      [7, 4, 0, 3]]
    v = Array.new
    (1..8).each {
      v << Array.new(3,0)
    }
    #p v
    v[0][0] = v[1][0] = v[2][0] = v[3][0] = -size / 2;
    v[4][0] = v[5][0] = v[6][0] = v[7][0] =  size / 2;
    v[0][1] = v[1][1] = v[4][1] = v[5][1] = -size / 2;
    v[2][1] = v[3][1] = v[6][1] = v[7][1] =  size / 2;
    v[0][2] = v[3][2] = v[4][2] = v[7][2] = -size / 2;
    v[1][2] = v[2][2] = v[5][2] = v[6][2] =  size / 2;
    #p v

    (0..5).each {|j|       i = 5-j
      GL.Begin(type);
      GL.Normal(n[i])
      GL.Vertex(v[faces[i][0]])
      GL.Vertex(v[faces[i][1]])
      GL.Vertex(v[faces[i][2]])
      GL.Vertex(v[faces[i][3]])
      GL.End()
      #p [i, n[i]]
      #p [faces[i][0], faces[i][1], faces[i][2], faces[i][3]]
      #p [v[faces[i][0]], v[faces[i][1]], v[faces[i][2]], v[faces[i][3]]]
    }
  end
  def GLUT.WireCube(size)
    GLUT.drawBox(size, GL::LINE_LOOP)
  end
  def GLUT.SolidCube(size)
    GLUT.drawBox(size, GL::QUADS)
  end

  #----------------------------------------------------------------------
  def GLUT.InitDisplayMode(a) end
  def GLUT.InitWindowPosition(a,b) end
  def GLUT.CreateSubWindow(a,b,c,d,e) end
  def GLUT.DestroyWindow(a) end
  def GLUT.PostRedisplay() end
  def GLUT.SwapBuffers() end
  def GLUT.GetWindow() end
  def GLUT.SetWindow(a) end
  def GLUT.SetWindowTitle(a) end
  def GLUT.SetIconTitle(a) end
  def GLUT.PositionWindow(a,b) end
  def GLUT.ReshapeWindow(a,b) end
  def GLUT.PopWindow() end
  def GLUT.PushWidow() end
  def GLUT.IconifyWindow() end
  def GLUT.ShowWindow() end
  def GLUT.HideWindow() end
  def GLUT.FullScreen() end
  def GLUT.SetCurcor(a) end
  def GLUT.WarpPointer(a,b) end
  def GLUT.EstablishOverlay() end
  def GLUT.RemoveOverlay() end
  def GLUT.UseLayer(a) end
  def GLUT.PostOverlayRedisplay() end
  def GLUT.ShowOverlay() end
  def GLUT.HideOverlay() end
  def GLUT.CreateMenu(a) end
  def GLUT.DestroyMenu(a) end
  def GLUT.GetMenu() end
  def GLUT.SetMenu(a) end
  def GLUT.AddMenuEntry(a,b) end
  def GLUT.AddSubMenu(a,b) end
  def GLUT.ChangeToMenuEntry(a,b,c) end
  def GLUT.ChangeToSubMenu(a,b,c) end
  def GLUT.RemoveMenuItem(a) end
  def GLUT.AttachMenu(a) end
  def GLUT.DetachMenu(a) end

  def GLUT.SetColor(a,b,c,d) end
  def GLUT.GetColor(a,b) end
  def GLUT.CopyColormap(a) end
  def GLUT.Get(a) end
  def GLUT.DeviceGet(a) end
  def GLUT.ExtensionSupported(a) end
  def GLUT.GetModifiers() end
  def GLUT.LayerGet(a) end
  def GLUT.BitmapCharacter(a,b) end
  def GLUT.BitmapWidth(a,b) end
  def GLUT.StrokeCharacter(a,b) end
  def GLUT.StrokeWidth(a,b) end
  def GLUT.BitmapLength(a,b) end
  def GLUT.StrokeLength(a,b) end
  def GLUT.WireCone(a,b,c,d) end
  def GLUT.SolidCone(a,b,c,d) end
  def GLUT.WireTorus(a,b,c,d) end
  def GLUT.SolidTorus(a,b,c,d) end
  def GLUT.WireDodecahedron() end
  def GLUT.SolidDodecahedron() end
  def GLUT.WireTeapot(a) end
  def GLUT.SolidTeapot(a) end
  def GLUT.WireOctahedron() end
  def GLUT.SolidOctahedron() end
  def GLUT.WireTetrahedron() end
  def GLUT.SolidTetrahedron() end
  def GLUT.WireIcosahedron() end
  def GLUT.SolidIcosahedron() end
  def GLUT.VideoResizeGet(a) end
  def GLUT.SetupVideoResizing() end
  def GLUT.StopVideoResizing() end
  def GLUT.VideoResize(a,b,c,d) end
  def GLUT.VideoPan(a,b,c,d) end
  def GLUT.ReportErrors() end
  def GLUT.IdleFunc(a) end
  def GLUT.TimerFunc(a,b,c) end

  API_VERSION = 0
  XLIB_IMPLEMENTATION = 0
  RGB = 0
  RGBA = 0
  INDEX = 0
  SINGLE = 0
  DOUBLE = 0
  ACCUM = 0
  ALPHA = 0
  DEPTH = 0
  STENCIL = 0
  MULTISAMPLE = 0
  STEREO = 0
  LUMINANCE = 0
  LEFT_BUTTON = 0
  MIDDLE_BUTTON = 0
  RIGHT_BUTTON = 0
  DOWN = 0
  UP = 0
  KEY_F1 = 0
  KEY_F2 = 0
  KEY_F3 = 0
  KEY_F4 = 0
  KEY_F5 = 0
  KEY_F6 = 0
  KEY_F7 = 0
  KEY_F8 = 0
  KEY_F9 = 0
  KEY_F10 = 0
  KEY_F11 = 0
  KEY_F12 = 0
  KEY_LEFT = 0
  KEY_UP = 0
  KEY_RIGHT = 0
  KEY_DOWN = 0
  KEY_PAGE_UP = 0
  KEY_PAGE_DOWN = 0
  KEY_HOME = 0
  KEY_END = 0
  KEY_INSERT = 0
  LEFT = 0
  ENTERED = 0
  MENU_NOT_IN_USE = 0
  MENU_IN_USE = 0
  NOT_VISIBLE = 0
  VISIBLE = 0
  HIDDEN = 0
  FULLY_RETAINED = 0
  PARTIALLY_RETAINED = 0
  FULLY_COVERED = 0
  RED = 0
  GREEN = 0
  BLUE = 0
  WINDOW_X = 0
  WINDOW_Y = 0
  WINDOW_WIDTH = 0
  WINDOW_HEIGHT = 0
  WINDOW_BUFFER_SIZE = 0
  WINDOW_STENCIL_SIZE = 0
  WINDOW_DEPTH_SIZE = 0
  WINDOW_RED_SIZE = 0
  WINDOW_GREEN_SIZE = 0
  WINDOW_BLUE_SIZE = 0
  WINDOW_ALPHA_SIZE = 0
  WINDOW_ACCUM_RED_SIZE = 0
  WINDOW_ACCUM_GREEN_SIZE = 0
  WINDOW_ACCUM_BLUE_SIZE = 0
  WINDOW_ACCUM_ALPHA_SIZE = 0
  WINDOW_DOUBLEBUFFER = 0
  WINDOW_RGBA = 0
  WINDOW_PARENT = 0
  WINDOW_NUM_CHILDREN = 0
  WINDOW_COLORMAP_SIZE = 0
  WINDOW_NUM_SAMPLES = 0
  WINDOW_STEREO = 0
  WINDOW_CURSOR = 0
  SCREEN_WIDTH = 0
  SCREEN_HEIGHT = 0
  SCREEN_WIDTH_MM = 0
  SCREEN_HEIGHT_MM = 0
  MENU_NUM_ITEMS = 0
  DISPLAY_MODE_POSSIBLE = 0
  INIT_WINDOW_X = 0
  INIT_WINDOW_Y = 0
  INIT_WINDOW_WIDTH = 0
  INIT_WINDOW_HEIGHT = 0
  INIT_DISPLAY_MODE = 0
  ELAPSED_TIME = 0
  HAS_KEYBOARD = 0
  HAS_MOUSE = 0
  HAS_SPACEBALL = 0
  HAS_DIAL_AND_BUTTON_BOX = 0
  HAS_TABLET = 0
  NUM_MOUSE_BUTTONS = 0
  NUM_SPACEBALL_BUTTONS = 0
  NUM_BUTTON_BOX_BUTTONS = 0
  NUM_DIALS = 0
  NUM_TABLET_BUTTONS = 0
  OVERLAY_POSSIBLE = 0
  LAYER_IN_USE = 0
  HAS_OVERLAY = 0
  TRANSPARENT_INDEX = 0
  NORMAL_DAMAGED = 0
  OVERLAY_DAMAGED = 0
  VIDEO_RESIZE_POSSIBLE = 0
  VIDEO_RESIZE_IN_USE = 0
  VIDEO_RESIZE_X_DELTA = 0
  VIDEO_RESIZE_Y_DELTA = 0
  VIDEO_RESIZE_WIDTH_DELTA = 0
  VIDEO_RESIZE_HEIGHT_DELTA = 0
  VIDEO_RESIZE_X = 0
  VIDEO_RESIZE_Y = 0
  VIDEO_RESIZE_WIDTH = 0
  VIDEO_RESIZE_HEIGHT = 0
  NORMAL = 0
  OVERLAY = 0
  ACTIVE_SHIFT = 0
  ACTIVE_CTRL = 0
  ACTIVE_ALT = 0
  CURSOR_RIGHT_ARROW = 0
  CURSOR_LEFT_ARROW = 0
  CURSOR_INFO = 0
  CURSOR_DESTROY = 0
  CURSOR_HELP = 0
  CURSOR_CYCLE = 0
  CURSOR_SPRAY = 0
  CURSOR_WAIT = 0
  CURSOR_TEXT = 0
  CURSOR_CROSSHAIR = 0
  CURSOR_UP_DOWN = 0
  CURSOR_LEFT_RIGHT = 0
  CURSOR_TOP_SIDE = 0
  CURSOR_BOTTOM_SIDE = 0
  CURSOR_LEFT_SIDE = 0
  CURSOR_RIGHT_SIDE = 0
  CURSOR_TOP_LEFT_CORNER = 0
  CURSOR_TOP_RIGHT_CORNER = 0
  CURSOR_BOTTOM_RIGHT_CORNER = 0
  CURSOR_BOTTOM_LEFT_CORNER = 0
  CURSOR_INHERIT = 0
  CURSOR_NONE = 0
  CURSOR_FULL_CROSSHAIR = 0

  def GLUT.MouseFunc(a) end
  def GLUT.MotionFunc(a) end
  def GLUT.PassiveMotionFunc(a) end
  def GLUT.EntryFunc(a) end
  def GLUT.VisibilityFunc(a) end
  def GLUT.IdleFunc(a) end
  def GLUT.TimerFunc(a) end
  def GLUT.MenuStateFunc(a) end
  def GLUT.SpecialFunc(a) end
  def GLUT.SpaceballMotionFunc(a) end
  def GLUT.SpaceballRotateFunc(a) end
  def GLUT.SpaceballButtonFunc(a) end
  def GLUT.ButtonBoxFunc(a) end
  def GLUT.DialsFunc(a) end
  def GLUT.TabletMotionFunc(a) end
  def GLUT.TabletButtonFunc(a) end
  def GLUT.MenuStatusFunc(a) end
  def GLUT.OverlayDisplayFunc(a) end
  def GLUT.WindowStatusFunc(a) end

  $w = GLUTWrapper.new

  #module_function :WireCube, :SolidCube
end

=begin
=end

#----------------------------------------------------------------------I
