#!/usr/local/bin/ruby -w
# simple graphics library by Kouichirou@Eto.com 2001/09/14
# for tamabi-idd

require 'sdl'
require 'opengl'
require 'sglconstant'
require 'sglvideo'
require 'sglcolor'
require 'sglobj'
require 'sglevent'

module SGL
  DEFAULT_FRAMERATE = 60

  def fov(f) $v.fov(f) end
  def window(a, b, c=nil, d=nil) $v.window(a,b,c,d) end #------------------------------------------------------------module functions
  def useDepth() $v.useDepth() end
  def background(x, y=nil, z=nil, a=nil) $v.background(x,y,z,a) end
  def backgroundHSV(x, y=nil, z=nil, a=nil) $v.backgroundHSV(x,y,z,a) end
  def color(x, y=nil, z=nil, a=nil) $v.color(x,y,z,a) end
  def colorHSV(x, y=nil, z=nil, a=nil)   $v.colorHSV(x,y,z,a) end

  def width() $v.width end
  def height() $v.height end

  def mouseX() $v.mouseX end #----------------------------------------------------------------------event
  def mouseY() $v.mouseY end
  def mouseDown() $v.mouseDown end
  def key(k) $v.key[k] end

  def setup() end #----------------------------------------------------------------------callback functions
  def display() end
  def onMouseDown(x,y) end
  def onMouseUp(x,y) end
  def onKeyDown(k) end
  def onKeyUp(k) end
  def onMidiOn(ch, note, vel) end
  def onMidiOff(ch, note) end

  def delay(msec=1000/DEFAULT_FRAMERATE) sleep msec/1000.0 end
  def wait() flip if !$flipped; loop { check_event; delay; } end
  def check_event
    e = $v.event
    while e.poll != 0
      case e.type
      when SDL::Event::MOUSEBUTTONDOWN
	$v.mouseX, $v.mouseY = $v.left + e.mouseX, $v.bottom + ($v.height - e.mouseY) #mouseʒũ`FbN
	$v.mouseDown = true
	onMouseDown($v.mouseX, $v.mouseY)
      when SDL::Event::MOUSEBUTTONUP
	$v.mouseX, $v.mouseY = $v.left + e.mouseX, $v.bottom + ($v.height - e.mouseY) #mouseʒũ`FbN
	$v.mouseDown = false
	onMouseUp($v.mouseX, $v.mouseY)
      when SDL::Event::KEYDOWN
	key = e.info[2]	#p [$v.event, $v.event.type, $v.event.info]
	exit if key == SDL::Key::ESCAPE #I`FbN
	if SDL::Key::A <= key && key <= SDL::Key::Z
	  onKeyDown(key - SDL::Key::A + 1)
	  $v.key[key - SDL::Key::A + 1] = true
	end
      when SDL::Event::KEYUP
	key = e.info[2] #p [$v.event, $v.event.type, $v.event.info]
	if SDL::Key::A <= key && key <= SDL::Key::Z
	  onKeyUp(key - SDL::Key::A + 1)
	  $v.key[key - SDL::Key::A + 1] = false
	end
      when SDL::Event::QUIT
	exit
      end
    end
  end
  def before_frame
    $v.set_camera_position
    check_event
    $v.clear
  end
  def after_frame
    $flipped = true
    SDL.GLSwapBuffers; GC.start
    delay
  end
  def mainloop()
    setup
    loop {
      before_frame
      display
      after_frame
    }
  end
  def flip()
    after_frame
    before_frame
  end

  #alias paper background #----------------------------------------------------------------------dbn compatible
  #alias pen color
  #alias size window #----------------------------------------------------------------------prose55ing compatible
  #alias fill color
  #alias stroke color

  def useMidi()   require 'sglmidi';   $midi   = SGLMidi.new   end #----------------------------------------------------------------------MIDI
  def useMidiIn()
    require 'sglmidiin';
    #$midiin = SGLMidiIn.new
  end

  #----------------------------------------------------------------------w֐
  def abs(a) a.abs end
end

#----------------------------------------------------------------------I
