#!/usr/local/bin/ruby -w
# simple graphics library by Kouichirou@Eto.com 2001/09/20

require 'midiout'

module SGL
  class SGLMidi
    def initialize
      @mout = Midi::MidiOut.new
      @mout.devNames
      @mout.open -1
      Thread.abort_on_exception = true
      programchange(1, 1)
      programchange(2, 9)
      programchange(3, 17)
      programchange(4, 25)
      programchange(5, 33)
      programchange(6, 41)
      programchange(7, 49)
      programchange(8, 57)
      programchange(9, 65)
      programchange(10, 73)
      programchange(11, 81)
      programchange(12, 89)
      programchange(13, 97)
      programchange(14, 105)
      programchange(15, 113)
      programchange(16, 121)
    end
    def shortmessage(a, b, c)
      a = 0  if a < 0
      a = 255 if 255 < a
      b = 0   if b < 0
      b = 127 if 127 < b
      c = 0   if c < 0
      c = 127 if 127 < c
      mess = a | b << 8 | c << 16; #printf("mess:%x\n", mess)
      @mout.out(mess)
    end
    def shortmess(u, ch, b, c)
      #p [u,ch,b,c]
      ch -= 1
      ch = 0  if ch < 0
      ch = 15 if 15 < ch
      shortmessage(u | ch, b,c)
    end
    def programchange(ch,b)
      #p [ch,b]
      shortmess(0xc0, ch, b-1,0)
    end
    def controlchange(ch,b,c) shortmess(0xb0, ch, b,c) end
    def noteon(ch, note, vel)
      vel = (127.0 * vel / 100.0).to_i
      shortmess(0x90, ch, note, vel)
    end
    def noteoff(ch, note, vel=0) noteon(ch, note, 0) end
    def note(ch, note, vel, msec)
      Thread.new {
	noteon(ch, note, vel)
	sleep msec/1000.0
	noteoff(ch, note)
      }
    end
  end
  #----------------------------------------------------------------------֐
  def programchange(ch,b)       $midi.programchange(ch,b) end
  def controlchange(ch,b,c)     $midi.controlchange(ch,b,c) end
  def note(ch, note, vel, msec) $midi.note(ch, note, vel, msec) end
  def noteon(ch, note, vel)     $midi.noteon(ch, note, vel) end
  def noteoff(ch, note)         $midi.note(ch, note) end
end

#----------------------------------------------------------------------I
