#!/usr/local/bin/ruby -w
# by Kouichirou@Eto.com 2001/09/19

module SGL
  class Video #----------------------------------------------------------------------ʏo͊֌W
    DEFAULT_WIDTH, DEFAULT_HEIGHT = 100, 100
    DEFAULT_FOV = 45
    def initialize
      @window_initialized = false
      @width, @height = DEFAULT_WIDTH, DEFAULT_HEIGHT
      @fov = DEFAULT_FOV
      @left, @bottom, @right, @top = 0,0,@width, @height
      @cameraX, @cameraY, @cameraZ = 0,0,5
      @use_depth = false
      SDL.init(SDL::INIT_VIDEO)
      SDL.setGLAttr(SDL::GL_DOUBLEBUFFER, 1)
      SDL.setGLAttr(SDL::GL_RED_SIZE,   5)
      SDL.setGLAttr(SDL::GL_GREEN_SIZE, 5)
      SDL.setGLAttr(SDL::GL_BLUE_SIZE,  5)
      SDL.setGLAttr(SDL::GL_DEPTH_SIZE, 16)
      @rgb = ColorRGB.new(100, 100, 100, 100)
      @hsv = ColorHSV.new(100, 100, 100, 100)
      @flipped = false
      @event = SDL::Event.new #----------------------------------------------------------------------event֌W
      @mouseX = @mouseY = @mouseDown = nil;       @key = []
    end
    attr_reader :width, :height, :event
    attr_reader :left, :bottom, :right, :top
    attr_accessor :mouseX, :mouseY, :mouseDown, :key
    def fov(f) @fov = f; end
    def window(a, b, c=nil, d=nil) #----------------------------------------------------------------------window
      if c == nil || d == nil
	@left, @bottom, @right, @top = 0,0,a,b
      else
	@left, @bottom, @right, @top = a,b,c,d
      end
      @width, @height = (@right-@left), (@top-@bottom)
      SDL.setVideoMode(@width, @height+1, 0, SDL::OPENGL); GC.start
      SDL::WM.setCaption('sgl', 'sgl'); @window_initialized = true
      gl_init
      background(0); color(100)
    end
    def useDepth() @use_depth = true; end
    def gl_init
      @cameraX, @cameraY = ((@left + @right)/2), ((@bottom + @top)/2)
      @cameraZ = 1.0 + @height / (2.0 * Math.tan(Math::PI * (@fov/2.0) / 180.0)); #p [@cameraX, @cameraY, @cameraZ]
      GL.BlendFunc(GL::SRC_ALPHA, GL::ONE_MINUS_SRC_ALPHA); GL.Enable(GL::BLEND)
      GL.Viewport(0, 0, @width, @height)
      GL.MatrixMode(GL::PROJECTION)
      loadIdentity()
      GLU.Perspective(@fov, @width/@height.to_f, 0.1, 10000.0) #GL.Ortho(-1, @width, 0, @height, -10000.0, 10000.0)
      set_camera_position
      GL.Enable(GL::DEPTH_TEST) if @use_depth
      #GL.DepthFunc(GL::LESS) if @use_depth
      #GL.DepthFunc(GL::LEQUAL) if @use_depth
      GL.ShadeModel(GL::SMOOTH)
      #GL.ClearDepth(1000000.0)
    end
    def background(x, y=nil, z=nil, a=nil)    GL.ClearColor(*@rgb.gl(x,y,z,a)); clear; end
    def backgroundHSV(x, y=nil, z=nil, a=nil) GL.ClearColor(*@hsv.gl(x,y,z,a)); clear; end
    def color(x, y=nil, z=nil, a=nil)    GL.Color(*@rgb.gl(x,y,z,a)) end
    def colorHSV(x, y=nil, z=nil, a=nil) GL.Color(*@hsv.gl(x,y,z,a)) end
    def clear() GL.Clear(GL::COLOR_BUFFER_BIT | GL::DEPTH_BUFFER_BIT) end
    def loadIdentity() GL.LoadIdentity() end
    def set_camera_position()
      GL.MatrixMode(GL::MODELVIEW)
      loadIdentity()
      GLU.LookAt(@cameraX,@cameraY,@cameraZ, @cameraX,@cameraY,0, 0,1,0)
    end
    #----------------------------------------------------------------------obj
    def lines()
      
    end
    
  end
end

=begin
window
void EtoVideo::glInit(){
  glViewport(0, 0, Width, Height);
  glClearColor(0.0f, 0.0f, 0.0f, 0.0f);		// This Will Clear The Background Color To Black
  glClearDepth(1.0);				// Enables Clearing Of The Depth Buffer
  //glDepthFunc(GL_LESS);				// The Type Of Depth Test To Do
  //glEnable(GL_DEPTH_TEST);			// Enables Depth Testing
  //glAlphaFunc(GL_LESS, 1.0);
  //glEnable(GL_ALPHA_TEST); //by eto 010205
  glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
  glEnable(GL_BLEND); //by eto 010205
  glShadeModel(GL_SMOOTH);			// Enables Smooth Color Shading
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();				// Reset The Projection Matrix
  gluPerspective(45.0f,(GLfloat)Width/(GLfloat)Height,0.1f,100.0f);	// Calculate The Aspect Ratio Of The Window
  glMatrixMode(GL_MODELVIEW);
=end

#----------------------------------------------------------------------I

